<template>
  <div>
    <el-upload
      ref="upload"
      action=""
      :class="`upload-image${type ? ' ' + type : ''}`"
      :before-upload="beforeUpload"
      :multiple="multiple"
      :auto-upload="autoUpload"
      :show-file-list="false"
      :on-progress="progressUpload"
      :on-success="successUpload"
      :on-error="errorUpload"
      :on-change="changeUpload"
      drag
      v-wave
      accept=".jpeg,.jpg,.png,.gif,.mp4,.avi,.mov,.m4v"
    >
      <template v-if="type == 'preview'">
        <div class="upload-image__icon">
          <svg-icon name="upload-small" />
        </div>
        <div class="upload-image__title">{{ $t('buttons.upload') }}</div>
      </template>
      <template v-else-if="type == 'avatar'">
        <svg-icon name="photo" />
      </template>
      <template v-else>
        <div>
          <div class="upload-image__title" :class="{ loading: uploadFile > 0 }">
            <template v-if="uploadFile > 0">
              {{ uploadFile }} / {{ totalFile }}
            </template>
            <template v-else>{{ $t('upload.title') }}</template>
          </div>
          <div class="upload-image__descr">
            <template v-if="uploadFile > 0"> Uploading... </template>
            <template v-else>
              {{ $t('upload.drag') }}
            </template>
          </div>
        </div>
        <div class="hide-mobile">
          <div class="upload-image__icon">
            <svg-icon name="upload" />
          </div>
        </div>
      </template>
    </el-upload>
  </div>
</template>

<script lang="ts">
import { defineComponent, useContext, ref } from '@nuxtjs/composition-api'
import { Upload, Upload as ElUpload } from 'element-ui'

export default defineComponent<{
  id: string
  where: 'avatar' | 'album' | 'event' | 'portfolio' | 'folder' | undefined
  size: String
  type: String
  onUpload: any
  multiple: boolean | false
  autoUpload: boolean | true
  counUpload: number | 0
}>({
  name: 'Upload',
  props: [
    'id',
    'where',
    'size',
    'type',
    'onUpload',
    'multiple',
    'autoUpload',
    'counUpload'
  ],
  components: { Upload },
  setup(props, { root }) {
    const { app } = useContext()
    const uploadFile = ref(0)
    const totalFile = ref(0)

    // const beforeUpload = async (file: File) => {
    //   try {
    //     await app.$api.storage.upload(
    //       `public/web/media/${Date.now()}.jpg`,
    //       file,
    //       {
    //         type: 'album',
    //         object_id: props.id
    //       }
    //     )
    //   } catch (e) {
    //   } finally {
    //   }
    // }

    const beforeUpload = async (file: File) => {
      if (props.where && props.id) {
        try {
          await app.$api.storage.upload(
            `public/web/media/${Date.now()}.jpg`,
            file,
            {
              type: props.where,
              object_id: props.id
            }
          )
        } finally {
          // const inputFiles = <ElUpload>root.$refs.upload
          // inputFiles.clearFiles()
          // root.$message({
          //   message: 'Success 👌',
          //   type: 'success'
          // })
        }
      } else {
        await app.$api.storage.upload(
          `public/web/media/${Date.now()}.jpg`,
          file,
          {
            type: props.where
          }
        )
      }
    }

    const progressUpload = (event: any, file: any, fileList: any) => {
      uploadFile.value++
      // totalFile.value = fileList.length
      // if (totalFile.value == 0) {
      //   totalFile.value = fileList.length
      // }
      // console.log(uploadFile.value)
      // console.log(totalFile.value)
      // if (uploadFile.value == totalFile.value) {
      //   uploadFile.value = 0
      //   totalFile.value = 0
      //   root.$message({
      //     message: 'Success 👌',
      //     type: 'success'
      //   })
      //   console.log(uploadFile.value)
      //   console.log(totalFile.value)
      // }
    }

    const clearFiles = () => {
      const inputFiles = <ElUpload>root.$refs.upload
      inputFiles.clearFiles()
    }
    const successUpload = (response: any, file: any, fileList: any) => {
      // uploadFile.value++
      if (uploadFile.value == totalFile.value) {
        root.$message({
          message: 'Success 👌',
          type: 'success'
        })
        uploadFile.value = 0
        //clearFiles()
        //const inputFiles: any = root.$refs.upload
      }
      //   console.log(uploadFile.value)
      //   console.log(totalFile.value)
      // }
    }

    const errorUpload = (err: any, file: any, fileList: any) => {
      root.$message({
        message: 'Sorry, something wrong 😩',
        type: 'error'
      })
    }

    const changeUpload = (file: any, fileList: any) => {
      totalFile.value = fileList.length
    }

    return {
      beforeUpload,
      changeUpload,
      progressUpload,
      successUpload,
      errorUpload,
      totalFile,
      uploadFile
    }
  }
})
</script>

<style lang="scss">
@import '~/assets/scss/element/common/var';
@import '~/assets/scss/element/upload';

.upload-image {
  $self: &;
  .el-upload {
    display: block;
  }
  .el-upload-dragger {
    width: 100%;
    height: auto;
    background: 0;
    border: 2px dashed #495271;
    border-radius: 10px;
    display: flex;
    align-items: center;
    justify-content: center;
    margin-bottom: 35px;
    padding: 35px;
    font-size: 0px;
    cursor: pointer;
    text-align: center;
    @media (min-width: 1199.98px) {
      justify-content: space-between;
      padding: 40px 60px 45px 60px;
      margin-bottom: 85px;
      text-align: left;
    }
  }
  &.avatar {
    border-radius: 50%;
    overflow: hidden;
    .el-upload-dragger {
      width: 60px;
      height: 60px;
      margin: 0px;
      padding: 0px;
      background: rgba($--color-success, 0.2);
      border: 0;
      border-radius: 50px;
      display: flex;
      align-items: center;
      justify-content: center;
      overflow: hidden;
      svg {
        width: 30px;
        height: 30px;
      }
    }
  }
  &.preview {
    .el-upload-dragger {
      border: 0;
      background: #353e5c;
      border-radius: 10px;
      flex-direction: column;
      padding: 20px;
      margin-bottom: 0px;
    }
    #{ $self }__title {
      font-size: 14px;
      line-height: 19px;
      letter-spacing: 0.7px;
      color: #ffffff;
      text-transform: uppercase;
    }
    #{ $self }__icon {
      margin-left: 0px;
      margin-bottom: 7px;
      svg {
        width: 30px;
        height: 20px;
      }
    }
  }

  .el-upload--picture-card {
    background: none;
    border: 0;
    border-radius: 0;
    box-sizing: border-box;
    width: auto;
    height: auto;
    line-height: 1;
  }

  &__title {
    font-weight: bold;
    font-size: 30px;
    line-height: 30px;
    letter-spacing: 0px;
    color: #0065ff;
    margin-bottom: 5px;
    text-transform: uppercase;
    &.loading {
      color: #00ffb3;
    }
  }
  &__descr {
    font-size: 20px;
    line-height: 25px;
    letter-spacing: 0px;
    color: #ffffff;
  }
  &__icon {
    flex: none;
    margin-left: 15px;
    svg {
      width: 50px;
      height: 50px;
      fill: #0065ff;
    }
  }
}
</style>
